=== modified file 'src/com/goldencode/p2j/oo/core/collections/Array.java'
--- src/com/goldencode/p2j/oo/core/collections/Array.java	2021-09-16 13:11:28 +0000
+++ src/com/goldencode/p2j/oo/core/collections/Array.java	2021-10-13 13:43:50 +0000
@@ -14,7 +14,9 @@
 **         20210113 Renamed clear() to clear_(), to follow NameConverter's rules.
 ** 006 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
-**     ME  20210916 Fix wrong method call on set (increment instead of decrement)
+**     ME  20210916 Fix wrong method call on set (increment instead of decrement). Clean-up resize
+**                  and fix 'retainAll' method.
+**     ME  20210929 Fix clone return value.
 */
 
 /*
@@ -197,7 +199,48 @@
    {
       integer newSize = TypeFactory.initInput(_newSize);
       internalProcedure(this, "Size", new Block((Body) () -> {
-         this.setArraySize(newSize.isUnknown() ? 0 : newSize.intValue());
+         if (newSize.isUnknown())
+         {
+            if (!discardOnShrink.booleanValue())
+            {
+               undoThrowTopLevel(ObjectOps.newInstance(ResizeError.class, "II",
+                        new character("Array"), new character("smaller")));
+            }
+
+            value = ArrayAssigner.resize(value, newSize);
+         }
+         else
+         {
+            integer initSize = getSize();
+
+            if (!CompareOps._isEqual(initSize, newSize))
+            {
+               if (initSize.isUnknown())
+               {
+                  value = ArrayAssigner.resize(value, newSize);
+               }
+               else
+               {
+                  if (CompareOps._isLessThan(newSize, initSize) && !discardOnShrink.booleanValue())
+                     undoThrowTopLevel(ObjectOps.newInstance(ResizeError.class, "II",
+                              new character("Array"), new character("smaller")));
+                  
+                  object<? extends com.goldencode.p2j.oo.lang._BaseObject_>[] tmpValue = TypeFactory
+                           .objectExtent(initSize.intValue(), BaseObject.class);
+
+                  tmpValue = (object<? extends _BaseObject_>[]) ArrayAssigner.assignMulti(tmpValue,
+                           value);
+
+                  value = ArrayAssigner.resize(value, new integer());
+                  value = ArrayAssigner.resize(value, newSize);
+
+                  for (int i = 0; i < initSize.intValue(); i++)
+                  {
+                     value[i] = tmpValue[i];
+                  }
+               }
+            }
+         }
       }));
    }
 
@@ -292,17 +335,17 @@
 
       return function(this, "AddArray", logical.class, new Block((Body) () -> {
          // OE bug, no check if extent is unknown - size is set to unknown
-
-         setArraySize(
-                  p1.length == 0 || getSize().isUnknown() ? 0 : p1.length + getSize().intValue());
-
-         for (int i = 1; i <= p1.length; i++)
+         if (p1.length > 0) 
          {
-            // incrementing an unknown is always unknown
-            setValue(p1[i - 1], getSize().isUnknown() ? new integer()
-                     : new integer(getSize().intValue() + i));
+            integer size = getSize();
+            
+            setSize(new integer(p1.length + size.getValue()));
+   
+            for (int i = 1; i <= p1.length; i++)
+            {
+               setValue(p1[i - 1], new integer(size.getValue() + i));
+            }
          }
-
          returnNormal(true);
       }));
    }
@@ -312,7 +355,7 @@
    public void clear_()
    {
       internalProcedure(this, "Clear", new Block((Body) () -> {
-         setArraySize(0);
+         setSize(new integer());
       }));
    }
 
@@ -320,8 +363,10 @@
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public object<? extends com.goldencode.p2j.oo.lang._BaseObject_> clone()
    {
+      object<? extends Icollection> clone = TypeFactory.object(Icollection.class);
+      
       return function(this, "Clone", object.class, new Block((Body) () -> {
-         object<? extends Array> clone = ObjectOps.newInstance(getClass());
+         clone.assign(ObjectOps.newInstance(getClass()));
 
          cloneElements(clone);
 
@@ -445,13 +490,14 @@
 
          for (int i = 1; i <= value.length; i++)
          {
-            if (!value[i].ref().legacyEquals(p1).booleanValue())
+            object<? extends _BaseObject_> obj = ArrayAssigner.subscript(this.value, i);
+            if (obj.ref().legacyEquals(p1).booleanValue())
             {
                // decrement reference to object
-               ObjectOps.decrement(value[i].ref());
+               ObjectOps.decrement(obj.ref());
 
                // set it to invalid
-               value[i] = new object<>();
+               ArrayAssigner.assignSingle(this.value, i, new object<>());
                returnNormal(new logical(true));
             }
          }
@@ -472,7 +518,7 @@
       return function(this, "RemoveAll", logical.class, new Block((Body) () -> {
          boolean lAny = false;
 
-         object<? extends Iiterator> iterator = iterator();
+         object<? extends Iiterator> iterator = p1.ref().iterator();
 
          while (iterator.ref().hasNext().booleanValue())
          {
@@ -513,59 +559,13 @@
       }));
    }
 
-   private void setArraySize(final int newSize)
-   {
-      if (newSize == 0)
-      {
-         if (!discardOnShrink.booleanValue())
-         {
-            undoThrowTopLevel(ObjectOps.newInstance(ResizeError.class, "II",
-                     new character("Array"), new character("smaller")));
-         }
-
-         value = ArrayAssigner.resize(value, new integer());
-      }
-      else
-      {
-         integer initSize = getSize();
-
-         if (initSize.isUnknown() || newSize != initSize.intValue())
-         {
-            if (initSize.isUnknown())
-            {
-               value = ArrayAssigner.resize(value, newSize);
-            }
-            else
-            {
-               if (newSize < initSize.intValue() && !discardOnShrink.booleanValue())
-                  undoThrowTopLevel(ObjectOps.newInstance(ResizeError.class, "II",
-                           new character("Array"), new character("smaller")));
-               
-               object<? extends com.goldencode.p2j.oo.lang._BaseObject_>[] tmpValue = TypeFactory
-                        .objectExtent(initSize.intValue(), BaseObject.class);
-
-               tmpValue = (object<? extends _BaseObject_>[]) ArrayAssigner.assignMulti(tmpValue,
-                        value);
-
-               value = ArrayAssigner.resize(value, new integer());
-               value = ArrayAssigner.resize(value, newSize);
-
-               for (int i = 0; i < initSize.intValue(); i++)
-               {
-                  value[i] = tmpValue[i];
-               }
-            }
-         }
-      }
-   }
-
    @LegacySignature(type = Type.METHOD, name = "SetValue", parameters = {
             @LegacyParameter(name = "p1", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT") })
    @LegacyResourceSupport(supportLvl = CVT_LVL_FULL | RT_LVL_FULL)
    public void setValue(final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _p1)
    {
       internalProcedure(this, "SetValue", new Block((Body) () -> {
-         setValue(_p1, getSize().isUnknown() ? getSize() : new integer(getSize().intValue() + 1));
+         setValue(_p1, getSize().isUnknown() ? getSize() : new integer(MathOps.plus(getSize(), 1)));
       }));
    }
 
@@ -581,11 +581,11 @@
 
       internalProcedure(this, "SetValue", new Block((Body) () -> {
 
-         if (!p2.isUnknown() && !getSize().isUnknown() && p2.intValue() > getSize().intValue())
+         if (CompareOps._isGreaterThan(p2, getSize()))
          {
             if (autoExpand.booleanValue())
             {
-               setArraySize(p2.intValue() + (int) Math.round(getSize().intValue() * 0.5));
+               setSize(new integer(MathOps.plus(p2, MathOps.round(MathOps.multiply(getSize(), 0.5), 0))));
             }
             else
             {
@@ -596,13 +596,16 @@
          }
 
          // decrement reference to previous object if any
-         if (!value[p2.intValue() - 1].isUnknown())
-            ObjectOps.decrement(value[p2.intValue() - 1].ref());
+         object<? extends _BaseObject_> obj = ArrayAssigner.subscript(value, p2);
+         
+         if (!obj.isUnknown())
+            ObjectOps.decrement(obj.ref());
 
          ArrayAssigner.assignSingle(value, p2, p1);
 
          // increment reference to object
-         ObjectOps.increment(p1.ref());
+         if (!p1.isUnknown())
+            ObjectOps.increment(p1.ref());
       }));
    }
 

=== modified file 'src/com/goldencode/p2j/oo/core/collections/ArrayIterator.java'
--- src/com/goldencode/p2j/oo/core/collections/ArrayIterator.java	2021-02-23 07:39:32 +0000
+++ src/com/goldencode/p2j/oo/core/collections/ArrayIterator.java	2021-09-28 07:53:08 +0000
@@ -9,6 +9,7 @@
 ** 002 CA  20210113 Renamed Iiterator.next to Iiterator.next_, to follow NameConverter's rules.
 ** 003 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                  signature.
+** 004 ME  20210927 Use '4GL' compare to account for unknown values.
 */
 
 /*
@@ -173,7 +174,7 @@
    {
       return function(ArrayIterator.class, this, "HasNext", logical.class, new Block((Body) () ->
       {
-         returnNormal(currentExtent.intValue() < iteratedArray.ref().getSize().intValue());
+         returnNormal(CompareOps.lessThan(currentExtent, iteratedArray.ref().getSize()));
       }));
    }
 
@@ -183,7 +184,7 @@
    {
       return function(ArrayIterator.class, this, "Next", object.class, new Block((Body) () ->
       {
-         currentExtent.assign(currentExtent.intValue() + 1);
+         currentExtent.assign(MathOps.plus(currentExtent, 1));
          returnNormal(iteratedArray.ref().getValue(currentExtent));
       }));
    }

=== modified file 'src/com/goldencode/p2j/oo/core/collections/LegacyMap.java'
--- src/com/goldencode/p2j/oo/core/collections/LegacyMap.java	2021-09-10 06:50:38 +0000
+++ src/com/goldencode/p2j/oo/core/collections/LegacyMap.java	2022-02-11 15:26:27 +0000
@@ -14,6 +14,7 @@
 ** 004 ME  20210325 Increment/decrement object references (key/value) when added/removed.
 **     ME  20210521 Use a 'key' object with hashCode/equals overrides.
 **     ME  20210902 Do not decrement reference for input parameter on remove.
+**     ME  20210929 Fix return object on get/put/remove.
 */
 
 /*
@@ -314,15 +315,16 @@
    {
       object<? extends com.goldencode.p2j.oo.lang._BaseObject_> poKey = TypeFactory
                .initInput(_poKey);
-
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> poRet = TypeFactory.object(_BaseObject_.class);
+      
       return function(LegacyMap.class, this, "Get", object.class, new Block((Body) () ->
       {
          keyobject key = new keyobject(poKey);
          
          if (map.containsKey(key))
-            returnNormal(map.get(key));
+            poRet.assign(map.get(key));
 
-         returnNormal(new object());
+         returnNormal(poRet);
       }));
    }
 
@@ -338,26 +340,31 @@
                .initInput(_poKey);
       object<? extends com.goldencode.p2j.oo.lang._BaseObject_> poValue = TypeFactory
                .initInput(_poValue);
-
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> poRet = TypeFactory.object(_BaseObject_.class);
+      
       return function(LegacyMap.class, this, "Put", object.class, new Block((Body) () ->
       {
          if (poKey.ref().equals(this))
             undoThrow(AppError.newInstance(new character("A Map cannot have itself as key.")));
 
-         if (poValue._isValid())
+         if (!poValue.isUnknown())
          {
             ObjectOps.increment(poValue.ref());
          }
          
-         object obj = map.put(new keyobject(poKey), poValue);
-
-         if (obj == null) 
+         poRet.assign(map.put(new keyobject(poKey), poValue));
+         
+         if (!poRet.isUnknown()) 
+         {
+            ObjectOps.decrement(poRet.ref());
+         }
+         else 
          {
             ObjectOps.increment(poKey.ref());
             size++;
          }
          
-         returnNormal(obj != null ? obj : new object());
+         returnNormal(poRet);
       }));
    }
 
@@ -388,21 +395,27 @@
    {
       object<? extends com.goldencode.p2j.oo.lang._BaseObject_> poKey = TypeFactory
                .initInput(_poKey);
-
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> poRet = TypeFactory.object(_BaseObject_.class);
+      
       return function(LegacyMap.class, this, "Remove", object.class, new Block((Body) () ->
       {
          if (!poKey.isValid().booleanValue())
             returnNormal(new object());
 
-         object obj = map.remove(poKey);
-         
-         if (obj != null && obj._isValid())
-            ObjectOps.decrement(obj.ref());
-         
-         if (obj != null)
+         poRet.assign(map.remove(new keyobject(poKey)));
+         
+         if (!poRet.isUnknown())
+         {
+            ObjectOps.decrement(poRet.ref());
             size--;
+         	
+            if (!map.containsKey(poKey))
+            {
+               ObjectOps.decrement(poKey.ref());
+            }
+         }
          
-         returnNormal(obj != null ? obj : new object());
+         returnNormal(poRet);
       }));
    }
 

=== modified file 'src/com/goldencode/p2j/oo/io/FileInputStream.java'
--- src/com/goldencode/p2j/oo/io/FileInputStream.java	2021-06-09 14:35:48 +0000
+++ src/com/goldencode/p2j/oo/io/FileInputStream.java	2021-10-13 13:43:50 +0000
@@ -12,8 +12,9 @@
 **     ME   20210204 Complete implementation as of OE12.2.
 ** 005 CA   20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy
 **                   signature.
-**     CA  20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
-**                  initialized at the method's execution, and not at the caller's arguments.
+**     CA   20210609 Updated INPUT/INPUT-OUTPUT parameters to the new approach, where they are explicitly 
+**                   initialized at the method's execution, and not at the caller's arguments.
+**     ME   20211001 Do not attempt to open the stream in ctor, delay it till read/skip is used.
 */
 
 /*
@@ -132,21 +133,6 @@
          
          this.fileName.assign(filename);
          
-         try
-         {
-            sFileStream.assign(StreamFactory.openFileStream((filename).toStringMessage(), false, false));
-            sFileStream.setBinary();
-            sFileStream.setConvert(false);
-            
-            FileSystemOps.initFileInfo(fileName);
-            fileSize = FileSystemOps.fileInfoGetSize().longValue();
-            bytesLeft = fileSize;
-         }
-         catch (Exception e)
-         {
-            undoThrow(SysError.newInstance("Cannot find or open file %s, errno = 2", 11294, true, false));
-         } 
-         
       }));
    }
    
@@ -167,7 +153,9 @@
    {
       internalProcedure(FileInputStream.class, this, "Close", new Block((Body) () -> 
       {
-         sFileStream.closeIn();
+         if(sFileStream.isValid())
+            sFileStream.closeIn();
+         
          super.close();
       }));
    }
@@ -262,6 +250,8 @@
             undoThrow(SysError.newInstance("Invalid value specified for parameter 'length' of method or constructor 'Read'", 18193, false, true));
          }
          
+         _checkOpen();
+         
          long toRead = bytesLeft;
          
          if (bytesLeft > 0)
@@ -328,4 +318,24 @@
          undoThrow(SysError.newInstance("Cannot invoke Read method in 'Progress.IO.FileInputStream' because it is not implemented", 18192, false, false));
       }));
    }
+   
+   private void _checkOpen () {
+      if (!sFileStream.isValid()) 
+      {
+         try
+         {
+            sFileStream.assign(StreamFactory.openFileStream((fileName).toStringMessage(), false, false));
+            sFileStream.setBinary();
+            sFileStream.setConvert(false);
+            
+            FileSystemOps.initFileInfo(fileName);
+            fileSize = FileSystemOps.fileInfoGetSize().longValue();
+            bytesLeft = fileSize;
+         }
+         catch (Exception e)
+         {
+            undoThrow(SysError.newInstance("Cannot find or open file %s, errno = 2", 11294, true, false));
+         }
+      }
+   }
 }

=== modified file 'src/com/goldencode/p2j/oo/json/objectmodel/JsonObject.java'
--- src/com/goldencode/p2j/oo/json/objectmodel/JsonObject.java	2021-09-17 15:14:10 +0000
+++ src/com/goldencode/p2j/oo/json/objectmodel/JsonObject.java	2022-02-11 15:26:27 +0000
@@ -24,6 +24,7 @@
 **     CA  20210816 Fixed clone() - object references must be incremented.
 **     OM  20210825 getJsonDataTypeName() is static now.
 **     VVT 20210917 Javadoc fixed. 
+**     ME  20210929 Fix return value on clone method.
 */
 
 /*
@@ -513,9 +514,12 @@
    @Override
    public object<? extends com.goldencode.p2j.oo.lang._BaseObject_> clone()
    {
+      object<JsonObject> cloned = TypeFactory.object(JsonObject.class);
+      
       return function(this, "Clone", object.class, new Block((Body) () ->
       {
-         object<JsonObject> cloned = ObjectOps.newInstance(JsonObject.class);
+         cloned.assign(ObjectOps.newInstance(JsonObject.class));
+         
          for (Map.Entry<String, Object> prop : properties.entrySet())
          {
             Object val = prop.getValue();

=== modified file 'src/com/goldencode/p2j/oo/json/objectmodel/ObjectModelParser.java'
--- src/com/goldencode/p2j/oo/json/objectmodel/ObjectModelParser.java	2022-01-20 16:27:48 +0000
+++ src/com/goldencode/p2j/oo/json/objectmodel/ObjectModelParser.java	2022-02-11 15:26:27 +0000
@@ -14,6 +14,7 @@
 ** 007 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     OM  20210329 FIX-CODEPAGE is emitted as static method call to accomodate dereferenciation cases.
 **     CA  20210709 JSON parse must use a pristine byte stream and use the reader to decode it.
+**     ME  20210929 Fix return value on parse methods.
 **     CA  20220120 Do not used TypeFactory.object when the OO reference must not be tracked or registered.
 **                  Do not use TypeFactory.object for internal usages, use ObjectVar if the reference must 
 **                  be tracked.
@@ -254,7 +255,6 @@
          }
          
          // empty string does not throw as for character/longchar so parse the string directly
-         
          try
          {
             res.assign(JsonBackend.instance().parse(source.getString(1).toStringMessage()));

=== modified file 'src/com/goldencode/p2j/oo/lang/LegacyClass.java'
--- src/com/goldencode/p2j/oo/lang/LegacyClass.java	2021-02-26 00:57:16 +0000
+++ src/com/goldencode/p2j/oo/lang/LegacyClass.java	2021-10-28 07:59:30 +0000
@@ -22,6 +22,7 @@
 **     GES 20200605 Fixed isValidEnum() processing.
 ** 009 CA  20210221 Fixed 'qualified', 'extent' and 'returns' annotations at the legacy signature.
 **     OM  20210225 Dropped duplicated error code.
+**     ME  20211028 Use 'POLY' data type for return/parameter on invoke/getPropertyValue/setPropertyValue.
 */
 
 /*
@@ -143,7 +144,7 @@
     * 
     * @return   See above.
     */
-   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "propName", type = "CHARACTER", mode = "INPUT")
    })
@@ -165,13 +166,13 @@
     * 
     * @return   See above.
     */
-   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "propName", type = "CHARACTER", mode = "INPUT"),
-      @LegacyParameter(name = "idx", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
+      @LegacyParameter(name = "idx", type = "BDT", mode = "INPUT")
    })
    @LegacyResourceSupport(supportLvl = CVT_LVL_PARTIAL|RT_LVL_STUB)
-   public Object getPropertyValue(character propName, object<? extends BaseObject> idx)
+   public Object getPropertyValue(character propName, Object idx)
    {
       // TODO:
       return new unknown();
@@ -187,7 +188,7 @@
     * 
     * @return   See above.
     */
-   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "instance", type = "OBJECT", qualified = "Progress.Lang.Object", mode = "INPUT"),
       @LegacyParameter(name = "propName", type = "CHARACTER", mode = "INPUT"),
@@ -212,21 +213,21 @@
     * 
     * @return   See above.
     */
-   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "GetPropertyValue", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "instance", type = "OBJECT", qualified = "Progress.Lang.Object", mode = "INPUT"),
       @LegacyParameter(name = "propName", type = "CHARACTER", mode = "INPUT"),
-      @LegacyParameter(name = "idx", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
+      @LegacyParameter(name = "idx", type = "BDT", mode = "INPUT")
    })
    @LegacyResourceSupport(supportLvl = CVT_LVL_PARTIAL|RT_LVL_STUB)
    public Object getPropertyValue(object<? extends _BaseObject_> instance, 
                                   character propName, 
-                                  object<? extends BaseObject> idx)
+                                  Object idx)
    {
       // TODO:
       return new unknown();
    }
-
+   
    /**
     * Resolve the legacy class from the given name.
     * 
@@ -743,7 +744,7 @@
     *            
     * @return    Any returned value, or unknown if the method is void.
     */
-   @LegacySignature(type = Type.METHOD, name = "invoke", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "invoke", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "method", type = "CHARACTER", mode = "INPUT")
    })
@@ -815,7 +816,7 @@
     *            
     * @return    Any returned value, or unknown if the method is void.
     */
-   @LegacySignature(type = Type.METHOD, name = "invoke", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "invoke", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "ref",    type = "OBJECT", mode = "INPUT", qualified = "Progress.Lang.Object"),
       @LegacyParameter(name = "parms",  type = "OBJECT", mode = "INPUT", qualified = "Progress.Lang.ParameterList")
@@ -846,7 +847,7 @@
     *            
     * @return    Any returned value, or unknown if the method is void.
     */
-   @LegacySignature(type = Type.METHOD, name = "invoke", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "invoke", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "ref",    type = "OBJECT",    mode = "INPUT", qualified = "Progress.Lang.Object"),
       @LegacyParameter(name = "method", type = "CHARACTER", mode = "INPUT"),
@@ -869,7 +870,7 @@
     *            
     * @return    Any returned value, or unknown if the method is void.
     */
-   @LegacySignature(type = Type.METHOD, name = "invoke", parameters = 
+   @LegacySignature(type = Type.METHOD, name = "invoke", returns = "BDT", parameters = 
    {
       @LegacyParameter(name = "ref",    type = "OBJECT",    mode = "INPUT", qualified = "Progress.Lang.Object"),
       @LegacyParameter(name = "method", type = "CHARACTER", mode = "INPUT"),
@@ -1272,60 +1273,55 @@
    @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = 
    {
       @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void setPropertyValue(final character _pname, final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _value)
-   {
-      character pname = TypeFactory.initInput(_pname);
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
-   }
-
-   @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = 
-   {
-      @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
-      @LegacyParameter(name = "index", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void setPropertyValue(final character _pname, final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _index, final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _value)
-   {
-      character pname = TypeFactory.initInput(_pname);
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> index = TypeFactory.initInput(_index);
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
-   }
-
-   @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = 
-   {
-      @LegacyParameter(name = "obj-ref", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
-      @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void setPropertyValue(final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _objRef, final character _pname, final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _value)
-   {
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> objRef = TypeFactory.initInput(_objRef);
-      character pname = TypeFactory.initInput(_pname);
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> value = TypeFactory.initInput(_value);
-      
-      internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
-   }
-
-   @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = 
-   {
-      @LegacyParameter(name = "obj-ref", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
-      @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
-      @LegacyParameter(name = "index", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
-      @LegacyParameter(name = "value", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT")
-   })
-   public void setPropertyValue(final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _objRef, final character _pname, final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _index, final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _value)
-   {
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> objRef = TypeFactory.initInput(_objRef);
-      character pname = TypeFactory.initInput(_pname);
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> index = TypeFactory.initInput(_index);
-      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> value = TypeFactory.initInput(_value);
-      
+      @LegacyParameter(name = "value", type = "BDT", mode = "INPUT")
+   })
+   public void setPropertyValue(final character _pname, final Object _value)
+   {
+      character pname = TypeFactory.initInput(_pname);
+      
+      internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
+   }
+
+   @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = {
+            @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
+            @LegacyParameter(name = "index", type = "BDT", mode = "INPUT"),
+            @LegacyParameter(name = "value", type = "BDT", mode = "INPUT") })
+   public void setPropertyValue(final character _pname, final Object _index,
+            final Object _value)
+   {
+      character pname = TypeFactory.initInput(_pname);
+
+      internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
+   }
+   
+   @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = 
+   {
+      @LegacyParameter(name = "obj-ref", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
+      @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
+      @LegacyParameter(name = "value", type = "BDT", mode = "INPUT")
+   })
+   public void setPropertyValue(final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _objRef, final character _pname, final Object _value)
+   {
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> objRef = TypeFactory.initInput(_objRef);
+      character pname = TypeFactory.initInput(_pname);
+      
+      internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
+   }
+
+   @LegacySignature(type = Type.METHOD, name = "SetPropertyValue", parameters = {
+            @LegacyParameter(name = "obj-ref", type = "OBJECT", qualified = "progress.lang.object", mode = "INPUT"),
+            @LegacyParameter(name = "pname", type = "CHARACTER", mode = "INPUT"),
+            @LegacyParameter(name = "index", type = "BDT", mode = "INPUT"),
+            @LegacyParameter(name = "value", type = "BDT", mode = "INPUT") })
+   public void setPropertyValue(
+            final object<? extends com.goldencode.p2j.oo.lang._BaseObject_> _objRef,
+            final character _pname, final Object _index,
+            final Object _value)
+   {
+      object<? extends com.goldencode.p2j.oo.lang._BaseObject_> objRef = TypeFactory
+               .initInput(_objRef);
+      character pname = TypeFactory.initInput(_pname);
+
       internalProcedure(LegacyClass.class, this, "SetPropertyValue", new Block());
    }
 }

